%define _use_internal_dependency_generator 0
%global buildcc gcc_3_4
%global debug_package %{nil}
%global momorel 2

Summary:	A CPU Emulator
Name:		qemu
Version:	0.9.1
Release:	%{momorel}m%{?dist}
License:	GPL
Group:		Development/Tools
URL:		http://fabrice.bellard.free.fr/qemu/
Source0:	http://fabrice.bellard.free.fr/qemu/%{name}-%{version}.tar.gz
NoSource: 0
Source1: qemu.init
Patch1: qemu-non-sdl_static.patch
Patch4: qemu-0.7.0-build.patch
Patch5: qemu-0.8.0-sdata.patch
Patch6: qemu-0.9.0-load-initrd.patch
Patch7: qemu-block-rw-rangecheck.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-root
PreReq: chkconfig
PreReq: initscripts
BuildRequires: SDL-devel >= 1.2.7-9m, time, zlib-devel >= 1.2.3-1m
BuildRequires: gcc3.4
Obsoletes: qemu-arm, qemu-ppc, qemu-sparc

%description
QEMU is a generic and open source processor emulator which achieves a good
emulation speed by using dynamic translation. QEMU has two operating modes:
 
 * Full system emulation. In this mode, QEMU emulates a full system (for
   example a PC), including a processor and various peripherials. It can be
   used to launch different Operating Systems without rebooting the PC or
   to debug system code.
 * User mode emulation. In this mode, QEMU can launch Linux processes compiled
   for one CPU on another CPU.

As QEMU requires no host kernel patches to run, it is safe and easy to use.

%prep
%setup -q
%patch1 -p1 -b .no-sdl_static
%patch4 -p1
# %patch5 -p1
# %patch6 -p0
%patch7 -p1


%build

CFLAGS=`echo %{optflags} | sed -e 's/-fstack-protector//g' -e 's/-mtune/-mcpu/g'` 

./configure \
        --prefix=%{_prefix} \
        --interp-prefix=%{_prefix}/qemu-%%M \
        --cc=%{buildcc} \
        --make=%{__make} \
        --enable-alsa
%make

%install
rm -rf %{buildroot}
%{__make} install \
  bindir=%{buildroot}%{_bindir} \
  datadir=%{buildroot}%{_datadir}/qemu \
  docdir=%{buildroot}%{_docdir}/%{name}-%{version} \
  mandir=%{buildroot}%{_mandir}

chmod -x %{buildroot}%{_mandir}/man1/*
install -D -p -m 0755 %{SOURCE1} %{buildroot}%{_initscriptdir}/qemu

%clean
rm -rf %{buildroot}

%preun
if [ $1 -eq 0 ]; then
    /sbin/service qemu stop &>/dev/null || :
    /sbin/chkconfig --del qemu
fi

%postun
if [ $1 -ge 1 ]; then
    /sbin/service qemu condrestart &>/dev/null || :
fi

%files
%defattr(-,root,root,-)
%doc Changelog README TODO
%doc qemu-doc.html qemu-tech.html
%doc COPYING COPYING.LIB LICENSE
%config %{_initscriptdir}/qemu
%{_bindir}/qemu*
%{_prefix}/share/qemu/
%{_mandir}/man1/*

%changelog
* Sun Mar  9 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (0.9.1-2m)
- [SECURITY] CVE-2008-0928

* Mon Jan  7 2008 Yohsuke Ooi <meke@momonga-linuc.org>
- (0.9.1-1m)
- update 0.9.1

* Sun Sep 23 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.9.0-5m)
- disabled debug_package

* Wed Jul 25 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.9.0-4m)
- PreReq: chkconfig, initscripts

* Wed Jun 20 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.9.0-3m)
- disable service at initial start up

* Tue Jun 12 2007 Yohsuke Ooi <meke@momonga-linuc.org>
- (0.9.0-2m)
- use gcc3.4

* Thu Jun  7 2007 Ryu SASAOKA <ryu@momonga-linuc.org>
- (0.9.0-1m)
- update to 0.9.0
- sync FC7 (0.9.0-2)

* Mon Jul 31 2006 Nishio Futoshi <futoshi@momonga-linuc.org>
- (0.8.2-1m)
- update to 0.8.2
- add patch3 (linux/compiler.h)

* Mon May 29 2006 Masanobu Sato <satoshiga@momonga-linux.org>
- (0.8.1-2m)
- add patch for x86_64 to disable sparc-softemu and sparc-user

* Thu May 11 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (0.8.1-1m)
- update 0.8.1
- disable make test

* Sun Jan  8 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (0.8.0-1m)
- update 0.8.0
- use gcc_3_2

* Thu Nov 17 2005 Kazuhiko <kazuhiko@fdiary.net>
- (0.7.2-2m)
- Obsoletes: qemu-arc, qemu-ppc, qemu-sparc

* Sat Nov 12 2005 Kazuhiko <kazuhiko@fdiary.net>
- (0.7.2-1m)

* Sat Jul 23 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (0.6.1-4m)
- rebuild against zlib-1.2.3 (CAN-2005-1849)

* Wed Jul 13 2005 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.6.1-3m)
- rebuild against zlib-devel 1.2.2-2m, which fixes CAN-2005-2096.

* Sat Feb 12 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (0.6.1-2m)
- rebuild against SDL-1.2.7-9m

* Wed Nov 17 2004 Kazuhiko <kazuhiko@fdiary.net>
- (0.6.1-1m)
- many bug fixes and new disk image formats
- remove qemu-cpu-exec.patch

* Wed Jul 14 2004 mutecat <mutecat@momonga-linux.org>
- (0.6.0-1m)
- update & add qemu-cpu-exec.patch
- qemu-cflags2.patch qemu-DESTDIR2.patch qemu-noinstall-htmlfiles2.patch
- patch shusei

* Sat Jun 12 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.5.5-2m)
- add qemu-noinstall-htmlfiles.patch
  for fix below
      error: Installed (but unpackaged) file(s) found:
         /usr/share/doc/qemu/qemu-doc.html
         /usr/share/doc/qemu/qemu-tech.html

* Tue May 18 2004 Kazuhiko <kazuhiko@fdiary.net>
- (0.5.5-1m)
- much improved windows 98 support
- VGA support in PowerPC PREP target

* Sat May 01 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.5.4-4m)
- add Patch2: qemu-DESTDIR.patch
- no use makeflags
- no use --interp-prefix

* Sat May  1 2004 Toru Hoshina <t@momonga-linux.org>
- (0.5.4-3m)
- linux_boot.bin
- force _use_internal_dependency_generator as 0.

* Thu Apr 29 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.5.4-2m)
- add Patch1: qemu-non-sdl_static.patch
- add hack for GLIBC_PRIVATE from valgrind.spec

* Wed Apr 28 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.5.4-1m)
- momonganized
- nosrc
- version up to 0.5.4
- comment out patch0
- update patch1, and rename patch0
- use %%{buildroot} nor $(DESTDIR) at makeflags 
- use %%{optflags} nor $RPM_OPT_FLAGS at configure
- tmp comment out %%check
- change License: GPL/LGPL to GPL

* Fri Jan  9 2004 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.5.1-0.fdr.1
- added -cflags patch to apply RPM_OPT_FLAGS
- added -ppc subpackage
- updated to 0.5.1

* Fri Nov 14 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.5.0-0.fdr.1
- updated to 0.5.0
- reworked large parts of the spec-file since upstream enables
  multi-target builds already

* Tue Sep  2 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.4.3-0.fdr.1.3
- s!%%ifnarch x86!%%ifnarch %%ix86!

* Tue Sep  2 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.4.3-0.fdr.1.2
- use '-Wl,-z -Wl,execstack' options to prevent crashes on exec-shield stack

* Thu Aug 21 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.4.3-0.fdr.1.1
- added -nostrip patch

* Thu Aug 21 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.4.3-0.fdr.1
- initial build
